﻿using System;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace cs31_webio_client
{
    public partial class Form1 : Form
    {
        
        Socket TCP_Client;

        byte[] receiveBuffer;
        string receiveString;

        private delegate void DelegateSub();


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            this.gb_io.Enabled = false;
            this.bt_disconnect.Enabled = false;
            this.sb_status.Text = "no connection";

        }
        //-------------------------------------------------------------------


        private void bt_connect_Click(object sender, EventArgs e)
        {
            
            if (this.ed_ip.Text != "" && this.ed_Port.Text != "")
            {
                try
                {
                    IPEndPoint ClientEP = new IPEndPoint(IPAddress.Parse(this.ed_ip.Text), int.Parse(this.ed_Port.Text));
                    TCP_Client = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                    TCP_Client.BeginConnect(ClientEP, new AsyncCallback(callback_connect), TCP_Client);
                }
                catch (Exception)
                {
                    closeConnection();
                    this.sb_status.Text = "Error while connecting!";
                }
            }else{
                this.sb_status.Text = "IP and Port needed!";
            }

        }
        //-------------------------------------------------------------------


        private void callback_connect(IAsyncResult ar)
        {

            try
            {
                TCP_Client.EndConnect(ar);

                this.sb_status.Text = "connected";
                
                this.Invoke(new DelegateSub(disconnectenable));

                this.receiveBuffer = new byte[512];
                TCP_Client.BeginReceive(receiveBuffer, 0, 512, SocketFlags.None, new AsyncCallback(callback_receive), TCP_Client);
            }
            catch (Exception)
            {
                closeConnection();
                this.sb_status.Text = "Error while connecting!";
            }

        }
        //-------------------------------------------------------------------    

        
        private void callback_receive(IAsyncResult ar)
        {

            int receiveCount = 0;

            try
            {
                if (TCP_Client != null)
                {
                    if (TCP_Client.Connected)
                    {
                        receiveCount = TCP_Client.EndReceive(ar);
                        receiveString = Encoding.ASCII.GetString(receiveBuffer);
                        Array.Clear(receiveBuffer, 0, 512);
                        this.Invoke(new DelegateSub(evaluateResponse));
                        TCP_Client.BeginReceive(receiveBuffer, 0, 512, SocketFlags.None, new AsyncCallback(callback_receive), TCP_Client);
                    }
                }
            }
            catch (Exception)
            {
                this.sb_status.Text = "Error while receiving!";
            }

            if (receiveCount == 0)
            {
                closeConnection();
            }
            
        }
        //------------------------------------------------------------------- 


        private void closeConnection()
        {

            try
            {
                if(TCP_Client != null)
                {
                    if (TCP_Client.Connected)
                    {
                        TCP_Client.Shutdown(SocketShutdown.Both);
                        TCP_Client.Close();
                        TCP_Client = null;
                    }
                }

                this.sb_status.Text = "no connection";

                this.Invoke(new DelegateSub(connectenable));
            }
            catch (Exception)
            {
                this.sb_status.Text = "Error while disconnecting!";
            }
            
        }
        //-------------------------------------------------------------------

        
        private void disconnectenable()
        {
            
            this.bt_disconnect.Enabled = true;
            this.bt_connect.Enabled = false;
            this.gb_io.Enabled = true;

        }
        //-------------------------------------------------------------------


        private void connectenable()
        {
            this.bt_disconnect.Enabled = false;
            this.bt_connect.Enabled = true;
            this.gb_io.Enabled = false;
        }
        //-------------------------------------------------------------------


        private void evaluateResponse()
        {

            try
            {
                switch (receiveString.Substring(0, 1))
                {
                    case "i":
                        if (receiveString.Substring(7, 2) == "on")
                        {
                            if (receiveString.Substring(5, 1) == "0")
                            {
                                this.cb_input0.Checked = true;
                            }
                            else
                            {
                                this.cb_input1.Checked = true;
                            }
                        }
                        else
                        {
                            if (receiveString.Substring(7, 3) == "off")
                            {
                                if (receiveString.Substring(5, 1) == "0")
                                {
                                    this.cb_input0.Checked = false;
                                }
                                else
                                {
                                    this.cb_input1.Checked = false;
                                }
                            }
                            else
                            {
                                if ( (int.Parse(receiveString.Substring(6, 1)) & 1) == 1 )
                                {
                                    cb_input0.Checked = true;
                                }
                                else
                                {
                                    cb_input0.Checked = false;
                                }
                                if ( (int.Parse(receiveString.Substring(6, 1)) & 2) == 2 )
                                {
                                    cb_input1.Checked = true;
                                }
                                else
                                {
                                    cb_input1.Checked = false;
                                }
                            }
                        }
                        break;

                    case "o":
                        if (receiveString.Substring(8, 2) == "on")
                        {
                            if (receiveString.Substring(6, 1) == "0")
                            {
                                this.cb_output0.Checked = true;
                            }
                            else
                            {
                                this.cb_output1.Checked = true;
                            }
                        }
                        else
                        {
                            if (receiveString.Substring(8, 3) == "off")
                            {
                                if (receiveString.Substring(6, 1) == "0")
                                {
                                    this.cb_output0.Checked = false;
                                }
                                else
                                {
                                    this.cb_output1.Checked = false;
                                }
                            }
                            else
                            {
                                if ( (int.Parse(receiveString.Substring(7, 1)) & 1) == 1 )
                                {
                                    cb_output0.Checked = true;
                                }
                                else
                                {
                                    cb_output0.Checked = false;
                                }
                                if ( (int.Parse(receiveString.Substring(7, 1)) & 2) == 2 )
                                {
                                    cb_output1.Checked = true;
                                }
                                else
                                {
                                    cb_output1.Checked = false;
                                }
                            }
                        }
                        break;

                    case "c":
                        int tabpos;

                        if (receiveString.Substring(7, 1) == "0")
                        {
                            ed_counter0.Text = receiveString.Substring(9, receiveString.Length - 10);
                        }
                        if (receiveString.Substring(7, 1) == "1")
                        {
                            ed_counter1.Text = receiveString.Substring(9, receiveString.Length - 10);
                        }
                        if (receiveString.Substring(7, 1) == ";")
                        {
                            tabpos = receiveString.IndexOf(";", 8);
                            ed_counter0.Text = receiveString.Substring(8, tabpos - 9);
                            ed_counter1.Text = receiveString.Substring(tabpos, receiveString.Length - tabpos - 1);
                        }
                        break;
                }
            }
            catch (Exception)
            {
                this.sb_status.Text = "Error while receiving";
            }

        }
        //-------------------------------------------------------------------


        private void sendCmd(string cmd)
        {

            try
            {
                byte[] cmdBytes;
                cmdBytes = Encoding.ASCII.GetBytes(cmd);
                TCP_Client.Send(cmdBytes, cmdBytes.Length, SocketFlags.None);
            }
            catch (Exception)
            {
                this.sb_status.Text = "Error while sending command!";
            }

        }
        //-------------------------------------------------------------------


        private void ed_interval_TextChanged(object sender, EventArgs e)
        {
            this.Timer_polling.Interval = int.Parse(this.ed_interval.Text);
        }
        //-------------------------------------------------------------------


        private void cb_output_Click(object sender, EventArgs e)
        {

            try
            {
                CheckBox Cur_cb = (CheckBox)sender;
                int CurOutputNo = int.Parse(Cur_cb.Name.Substring(Cur_cb.Name.Length - 1, 1));

                if (Cur_cb.Checked)
                {
                    sendCmd("GET /outputaccess" + CurOutputNo + "?PW=" + ed_Password.Text + "&State=ON&");
                }
                else
                {
                    sendCmd("GET /outputaccess" + CurOutputNo + "?PW=" + ed_Password.Text + "&State=OFF&");
                }
            }
            catch (Exception)
            {
                this.sb_status.Text = "Error while sending command!";
            }

        }
        //-------------------------------------------------------------------


        private void bt_outputs_read_Click(object sender, EventArgs e)
        {

            sendCmd("GET /output?PW=" + ed_Password.Text + "&");

        }
        //-------------------------------------------------------------------


        private void bt_inputs_read_Click(object sender, EventArgs e)
        {

            sendCmd("GET /input?PW=" + ed_Password.Text + "&");

        }
        //-------------------------------------------------------------------


        private void bt_conter_readall_Click(object sender, EventArgs e)
        {

            sendCmd("GET /counter?PW=" + ed_Password.Text + "&");

        }
        //-------------------------------------------------------------------


        private void bt_counter_clearall_Click(object sender, EventArgs e)
        {

            sendCmd("GET /counterclear?PW=" + ed_Password.Text + "&");

        }
        //-------------------------------------------------------------------


        private void bt_counter_read_Click(object sender, EventArgs e)
        {
         
            Button Cur_bt = (Button)sender;
            int CurCounterNo = int.Parse(Cur_bt.Name.Substring(Cur_bt.Name.Length - 1, 1));

            sendCmd("GET /counter" + CurCounterNo.ToString() + "?PW=" + ed_Password.Text + "&");

        }
        //-------------------------------------------------------------------


        private void bt_counter_clear_Click(object sender, EventArgs e)
        {
            Button Cur_bt = (Button)sender;
            int CurCounterNo = int.Parse(Cur_bt.Name.Substring(Cur_bt.Name.Length - 1, 1));

            sendCmd("GET /counterclear" + CurCounterNo.ToString() + "?PW=" + ed_Password.Text + "&");
        }
        //-------------------------------------------------------------------


        private void bt_disconnect_Click(object sender, EventArgs e)
        {
            this.closeConnection();
        }
        //-------------------------------------------------------------------


        private void Timer_polling_Tick(object sender, EventArgs e)
        {
            if (TCP_Client != null)
            {
                if (TCP_Client.Connected)
                {
                    if (cb_output_polling.Checked)
                    {
                        sendCmd("GET /output?PW=" + ed_Password.Text + "&");
                    }
                    if (cb_input_polling.Checked)
                    {
                        sendCmd("GET /input?PW=" + ed_Password.Text + "&");
                    }
                    if (cb_counter_polling.Checked)
                    {
                        sendCmd("GET /counter?PW=" + ed_Password.Text + "&");
                    }
                }
            }
        }
        //--------------------------------------------------------------------------------------------
        
    }
}
